#include <fastgraf.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#endif

void main(void);

void main()
{
   int handle;
   int old_mode;
   int status;
#ifdef FG32
   char *buffer;
#else
   char huge *buffer;
#endif

   fg_initpm();
   if (fg_testmode(19,1) == 0)
   {
      printf("This program requires a 320 ");
      printf("x 200 MCGA graphics mode.\n");
      exit(1);
   }
   old_mode = fg_getmode();
   fg_setmode(19);
   fg_vbinit();

#ifdef FG32
   buffer = (char *)malloc(64000);
#elif defined(__TURBOC__)
   buffer = (char huge *)farmalloc(64000L);
#else
   buffer = (char huge *)halloc(64000L,1);
#endif
   if (buffer == NULL)
   {
      fg_setmode(old_mode);
      fg_reset();
      printf("Could not create the virtual buffer.\n");
      exit(1);
   }
   handle = fg_vbdefine(buffer,320,200);
   fg_vbopen(handle);

   status = fg_loadpcx("CORAL.PCX",0);
   if (status == 0)
   {
      fg_vbpaste(0,319,0,199,0,199);
      fg_waitkey();
   }

   fg_vbclose();
   fg_setmode(old_mode);
   fg_reset();

   if (status == 1)
      printf("CORAL.PCX not found.\n");
   else if (status == 2)
      printf("CORAL.PCX is not a PCX file.\n");
}
