#include <fastgraf.h>
#include <stdio.h>
#include <stdlib.h>
#if defined(__TURBOC__)
#include <alloc.h>
#else
#include <malloc.h>
#endif

void main(void);

void main()
{
   int handle1, handle2;
#ifdef FG32
   char *buffer1, *buffer2;
#else
   char far *buffer1, far *buffer2;
#endif

   fg_initpm();
   fg_setmode(19);
   fg_vbinit();

#ifdef FG32
   buffer1 = (char *)malloc(320*200);
   buffer2 = (char *)malloc(80*50);
#elif defined(__TURBOC__)
   buffer1 = (char far *)farmalloc(320L*200L);
   buffer2 = (char far *)farmalloc(80L*50L);
#else
   buffer1 = (char far *)halloc(320L*200L,1);
   buffer2 = (char far *)halloc(80L*50L,1);
#endif
   if (buffer1 == NULL || buffer2 == NULL)
   {
      fg_setmode(3);
      fg_reset();
      printf("Could not create the virtual buffers.\n");
      exit(1);
   }
   handle1 = fg_vbdefine(buffer1,320,200);
   handle2 = fg_vbdefine(buffer2,80,50);

   fg_vbopen(handle1);
   fg_loadpcx("CORAL.PCX",0);
   fg_vbpaste(0,319,0,199,0,199);
   fg_waitkey();

   fg_scale(buffer1,buffer2,320,200,80,50);
   fg_vbopen(handle2);
   fg_vbpaste(0,79,0,49,0,199);
   fg_waitkey();

   fg_vbclose();
   fg_setmode(3);
   fg_reset();
}
